    <!-- Guillaume Rozier 2020 - covidtracker.fr - tous droits réservés -->

    <div class="wp-block-button is-style-outline"><a class="wp-block-button__link" href="https://covidtracker.fr">&lt; Retour <b>Accueil</b></a></div>
    <br>
    <h2 style="margin-top: 60px;">Les fêtes de fin d'année sont-elles risquées ?</h2>
    <p>Cette question, on se l’est tous posée dernièrement : quelles sont les chances que quelqu’un qui porte le virus soit présent à un repas de Noël ? Quelle est la probabilité qu’un enfant de la classe de mon fils ait la Covid19 ? Grâce à cet outil, vous pouvez l’estimer.</p>
    <p>Pour cela, il vous suffit de choisir votre département et le nombre de personnes participant à l'événement, dans la partie "Mon événement" ci-dessous. Vous pouvez ajouter plusieurs départements afin de simuler un rassemblement de famille dont les membres viennent de différents départements, par exemple lors des fêtes de fin d'années. Vous pouvez aussi modifier manuellement l'incidence, vous retrouverez ce taux dans les <a href="https://raw.githubusercontent.com/CovidTrackerFr/covidtracker-data/master/images/charts/france/heatmaps_metropoles_0.jpeg">grandes métropoles ici</a>, par exemple.</p>

    <p>Les données de circulation du virus sont automatiquement mises à jour quotidiennement, et proviennent de Santé publique France. N'hésitez pas à réaliser une nouvelle simulation dans quelques jours.</p>

    <!-- wp:html -->
    <link href="https://cdn.jsdelivr.net/npm/select2@4.1.0-beta.1/dist/css/select2.min.css" rel="stylesheet"/>
    <script src="https://cdn.jsdelivr.net/npm/select2@4.1.0-beta.1/dist/js/select2.min.js"></script>
    
    <style>

  progress {
     /*-webkit-appearance: none;*/
     /*appearance: none;*/
     width:70%;
     height: 7px;
     margin-top: 0px !important;
     margin-bottom: 0px !important;
  }

  /* VALUE OF PROGRESSBAR */
  progress[type=green]::-webkit-progress-value{ /* Safari/Chrome */
      background:red;  
      background-color: green;
      border-radius: 5px;
  }

  progress[type=orange]::-webkit-progress-value{ /* Safari/Chrome */
      background:red;  
      background-color: orange;
      border-radius: 5px;
  }

  progress[type=red]::-webkit-progress-value{ /* Safari/Chrome */
      background:red;  
      background-color: red;
      border-radius: 5px;
  }

progress[type=black]::-webkit-progress-value{ /* Safari/Chrome */
      background:red;  
      background-color: black;
      border-radius: 5px;
  }

   /* REMAINING OF PROGRESSBAR */
  progress::-webkit-progress-bar { /* Safari/Chrome */
      background:red;
      background-color: rgba(20, 20, 20, 0.2); /*#c3d9c4;*/
      border-radius: 5px;
    }

    button {
      border: 0px solid;
      transition-duration: 0.4s;
      background-color: #ffffff;
      border-radius: 7px;
      
    		}

    button[type="form-btn"] {
      margin-right: 7px;
      margin-top: 3px;
      border: 0.5px solid;
      transition-duration: 0.4s;
      background-color: #ffffff;
      border-radius: 7px;
        }

    button[type="button_dep"]  {
      border: 0px solid;
      transition-duration: 0.4s;
      background-color: #ffffff;
      border-radius: 7px;
      box-shadow: 7px 4px 15px #d6d6d6;
      
    		}

        button[type="deps"] {
      margin-right: 7px;
      margin-top: 3px;
      border: 0.5px solid;
      transition-duration: 0.4s;
      background-color: #ffffff;
      border-radius: 7px;
        }

    .buttonSelected[type="form-btn"] {

      border: 2px solid black;
    }

    .buttonSelected[type=button_dep] {

      border: 3px solid black;
    }

    button:hover {
      background-color: black; /* Green */
      color: white;
    }
    input[type=text] {
      width: 50px;
      height: 30px;
      border: 0.5px solid;
      border-radius: 7px;
      padding: 10px;
      box-shadow: 2px 2px 5px #d6d6d6;
    }

    input[type=text_incid] {
      width: 70px;
      height: 30px;
      border: 0.25px solid;
      border-radius: 7px;
      padding: 10px;
      box-shadow: 2px 2px 5px #d6d6d6;
    }

    input[type=text]:focus {
      border: 2px solid #555;
    }
    input[type=text_incid]:focus {
      border: 3px solid #555;
    }

    .myDiv {
    	border: 0px solid black;
      padding: 10px 30px;
      border-radius: 7px;
    	max-width: 800px;
    	text-align: left;
      box-shadow: 7px 4px 25px #d6d6d6;
    	}

    </style>
  

    <h2 style="margin-top: 60px;">Mon événement</h2>
    <div class="myDiv" style="margin-top: 20px;">
        Lieu des participants :
          <select name="deps_list_choice" id="deps_list_choice_0" class="select2" onchange="listHasChanged();">
            <option value="">Choisissez un département...</option> 
          </select>
          

      <br>
      <br>

      Taux d'incidence mesuré :
      <input type="text_incid" id="tauxincid_0" onkeyup="tauxIncidHasChanged()" value="300">  / 100 000 hab.
      <span id="taux_incid_corrigé_0"></span>

      <br>
      <br>

      Nombre de personnes : 
      <input type="text" id="pers_0" onkeyup="nbPeopleHasChanged()" value="50">
      <br>
    </div>

    <div id="other_deps">
    </div>

    <button style="margin-top:20px;" type="form-btn" onclick="ajouterDepartement()">+ Ajouter un département</button>
    <button style="margin-top:20px;" type="form-btn" onclick="supprimerDepartement()">- Supprimer un département</button>

    <h2 style="margin-top: 60px;">Risque de l'événement</h2>
      <div class="myDiv" id="div_calculateur" style="margin-top: 20px;">
        <b><p>Le risque qu'il y ait une personne positive dans votre événement de <span id="nb_pers_result">--</span> personnes <span id="dep-name"></span>est de :</p></b>
        <span id="resultat" style="font-size: 50px;"></span><br>
        <span id="progress_bar"></span>
        <br>
        <br>
        <p>Dit autrement, si on observait 100 événements similaires à celui-ci, alors dans <span id="risque_autrement">--</span> d'entre eux il y aurait au moins un cas positif, qui pourrait à son tour contaminer les autres participants.</p>
      
        </div>

    

    <div class="myDiv" style="margin-top: 40px;">
      <p style="margin-top: 20px;">Si tous les français se réunissaient dans des événements de <span id="nb_pers_result_cas_contacts">--</span> personnes dans leur département, cela génèrerait jusqu'à <br><span style="font-size: 50px;" id="cas_contacts">--</span><br>cas contacts si tous les participants se croisent durant l'événement. Ces cas contacts pourraient eux-mêmes être contaminés si les gestes barrières n'ont pas été appliqués. Ce calcul repose sur la taille de l'événement, la population et le taux d'incidence actuel de chaque département.</p>
    </div>

    <div class="myDiv" id="list_deps_div" style="margin-top: 40px;">
      <p>Risque pour qu'il y ait une personne positive dans un événement de <span id="nb_pers_result_buttons">--  </span> personnes :</p>
      <span id="buttons-deps"></span>

    </div>

    <h2 style="margin-top: 60px;">Options</h2>
      <div class="myDiv" style="margin-top: 20px;">
        <div>
          Corriger le taux d'incidence officiel pour estimer le taux réel (on ne détecte actuellement que la moitié des cas réels) :<br>
          <button type="form-btn" id="2" onclick="btnCorrectionClicked('2')" class="buttonSelected">x2 (recommandé)</button><button type="form-btn" id="3" onclick="btnCorrectionClicked('3')">x3</button><button id="1" type="form-btn" onclick="btnCorrectionClicked('1')">Ne pas corriger</button>
        </div>
        <br>
      </div>

    <br>

    <i><span id="data_update">Mise à jour le <span id="date-update">-/-</span>, données du <span id="date-donnees">-/-</span>. Source des données : Santé publique France.</span></i>

    <br>
    <br>
        <p><i>Cet outil est un simulateur. Son résultat est issu d'une estimation, il est donc approximatif, et ne permet pas d'évaluer le risque d'un contact avec une personne contaminée. Nous ne pourrions pas être tenus reponsable en cas de contamination, même si le risque de présence d'un cas indiqué par le simulateur est faible ou nul.</i></p>
    <br>

    <h2 style="margin-top: 60px;">Comment ça marche ?</h2>

    <p> Pour comprendre comment ce simulateur fonctionne, on donne à chaque personne une probabilité p de porter le virus. <img width="700" src="https://covidtracker.fr/wp-content/uploads/2020/10/Diapositive1.jpg"></p>


    <p>À partir de là, prenons un évènement où 4 personnes se rendent. On va pouvoir calculer la probabilité qu’aucune ne soit malade : <img width="700" src="https://covidtracker.fr/wp-content/uploads/2020/10/Diapositive2.jpg"></p>

    <p>Or, cette probabilité p peut être estimée grâce au taux d’incidence : un taux d’incidence de 1 000 signifie que sur 100 000 personnes, 1 000 sont contaminées ; autrement dit, que 1 % des personnes sont contaminées. Ainsi, p = Taux d’incidence / 100 000. Notons que cette probabilité est potentiellement sous-évaluée, car elle ne prend en compte que les cas détectés par un test
    Les éléments logiques « au moins une personne porte le virus » et « aucune personne ne porte le virus » sont contraires ; on peut obtenir la probabilité du premier en soustrayant à 1 la probabilité du deuxième.
    Voilà comment ce simulateur fonctionne. Avec i le taux d’incidence et N le nombre de personnes, la probabilité qu’au moins une personne soit porteuse du Covid est égale à 1 – ( 1 – i / 100 000)^N. </p>

    <br>
    <p>Auteurs : <a href="https://twitter.com/eorphelin">Elias Orphelin</a></b>, <a href="https://twitter.com/guillaumerozier">Guillaume Rozier</a></b></p>
    <p>🇬🇧 <a href="https://covidtracker.fr/covid19-risk-calculator/">English version</a></p>



    <script>

    var departements = [];
    var selectedDep = "";
    var incidence=500;
    var taux_correction=2;

    var id_departements_a_afficher = [];
    var departements_a_afficher = {};
    var incidence_a_afficher = {};
    var nb_pers_a_afficher = {};  

    function ajouterDepartement(){
      last_id = 1;

      if(id_departements_a_afficher.length>0){
        last_id = id_departements_a_afficher[id_departements_a_afficher.length-1];
        last_id = last_id + 1;
      }
      id_departements_a_afficher.push(last_id);
      
      updateHtmlDeps();
      
      calculerResultat()
    }


    function supprimerDepartement(){
      
      id_dep_removed = id_departements_a_afficher.pop();
      delete id_departements_a_afficher[id_dep_removed];
      
      updateHtmlDeps();
      calculerResultat();
      
    }

    function updateHtmlDeps(){
      
      document.getElementById("other_deps").innerHTML = "";

      id_departements_a_afficher.forEach(id_dep => {
        document.getElementById("other_deps").innerHTML += div_other_dep(id_dep);
        updateList(id_dep);
        
      })
      

      id_departements_a_afficher.forEach(id_dep => {

        if(id_dep != last_id){
          
          document.getElementById("deps_list_choice_"+id_dep).value = departements_a_afficher[id_dep];

          document.getElementById("tauxincid_"+id_dep).value = incidence_a_afficher[id_dep];
          document.getElementById("pers_"+id_dep).value = nb_pers_a_afficher[id_dep];
          
          } 
        
        })
      
    }

    fetch('https://raw.githubusercontent.com/CovidTrackerFr/covidtracker-data/master/data/france/stats/incidence_departements.json')
       .then(response => {
           if (!response.ok) {
               throw new Error("HTTP error " + response.status);
           }
           return response.json();
       })
       .then(json => {
          this.data = json;

          departements = data["liste_departements"];
          incidence_departements = data["donnees_departements"];
          updateList();

          document.getElementById("date-update").innerHTML = data["date_update"];
          document.getElementById("date-donnees").innerHTML = data["date_donnees"];
          create_buttons();
          calculerNbCasContacts();
           
        })
       .catch(function () {
           this.dataError = true;
       }
      )


    function div_other_dep(id){

      let div_other_dep = `
          <div class="myDiv" style="margin-top: 20px;">
          
          Lieu des participants : 
          <select name="deps_list_choice" id="deps_list_choice_{{id}}" class="select2" onchange="listHasChanged({{id}});">
            <option value="">Choisissez un département...</option> 
          </select>

          <br>
          <br>

          Taux d'incidence mesuré :
          <input type="text_incid" id="tauxincid_{{id}}" onkeyup="tauxIncidHasChanged()" value="300">  / 100 000 hab.
          <span id="taux_incid_corrigé_{{id}}"></span>

          <br>
          <br>

          Nombre de personnes : 
          <input type="text" id="pers_{{id}}" onkeyup="nbPeopleHasChanged()" value="50">
          <br>
          </div>
          `;

          return div_other_dep.replaceAll("{{id}}", id);
    }

    function replaceBadCharacters(dep){
        return dep.replace("'", "&apos;").replace("ô", "&ocirc;")
      }

    function listHasChanged(id=0){

      let dep = document.getElementById('deps_list_choice_'+id).value;
      departements_a_afficher[id] = dep;
      updateButtonColor(dep);
      document.getElementById('tauxincid_'+id).value = incidence_departements[dep]["incidence_cas"];
      //document.getElementById("dep-name").innerHTML = "dans le département " + dep + " ";
      calculerResultat();

    }

    function scrollToTop(){
      const vw = Math.max(document.documentElement.clientWidth || 0, window.innerWidth || 0)
      const vh = Math.max(document.documentElement.clientHeight || 0, window.innerHeight || 0)

      if(vh < 2000){ 
        document.querySelector('#deps_list_choice_0').scrollIntoView({ 
          behavior: 'smooth' 
        });}
    }

    function updateList(id=0){
        html_str = "<option value=''>Choisissez un département...</option>";

        departements.sort().forEach(dep => {
          html_str += "<option value=\"" + dep + "\">" + dep + "</option>"
          }
        )

        document.getElementById("deps_list_choice_"+id).innerHTML = html_str;
    }

    tauxIncidHasChanged()
    
    function tauxIncidHasChanged() {
      //updateTextResultManualIncidence();

      calculerResultat()
      document.getElementById('deps_list_choice_0').value = "";
    }

    function updateTextResultManualIncidence(){
      document.getElementById("dep-name").innerHTML = "avec un taux d'incidence de " + document.getElementById('tauxincid_0').value + " (corrigé à " + document.getElementById('tauxincid_0').value * taux_correction + ")"+ " ";
  }

    function btnCorrectionClicked(correction){
      document.getElementById(taux_correction).classList.remove("buttonSelected");
      document.getElementById(correction).classList.add("buttonSelected");

      taux_correction=parseInt(correction);
      incidence = correctIncidence(correction);

      //updateTextResultManualIncidence();

      calculerResultat();
      //create_buttons();

    }

    function correctIncidence(correction){
      incidence = parseInt(correction) * document.getElementById("tauxincid_0").value;

      return incidence

    }

    function nbPeopleHasChanged(){
      calculerResultat();
      create_buttons();
    }

    function updateLocalVariables(){
      id_departements_a_afficher.forEach(id_dep => {
        departements_a_afficher[id_dep] = document.getElementById("deps_list_choice_"+id_dep).value;
        incidence_a_afficher[id_dep] = document.getElementById("tauxincid_"+id_dep).value;
        nb_pers_a_afficher[id_dep] = document.getElementById("pers_"+id_dep).value;
      })

    }

    function calculerNbPersTot(){
      document.getElementById("resultat").innerHTML = resultat.toString().replace(".", ",") + " %";

      nb_pers_tot = parseInt(document.getElementById("pers_0").value);
      id_departements_a_afficher.forEach(id_dep => {
        nb_pers_tot += parseInt(nb_pers_a_afficher[id_dep]);
      })
      return nb_pers_tot
    }

    function calculerResultat() {
      tauxincid = document.getElementById("tauxincid_0").value * taux_correction;

      updateLocalVariables();
      nb_pers_tot = calculerNbPersTot();

      pers = document.getElementById('pers_0').value

      mult = (1-tauxincid/100000)**pers

      if (id_departements_a_afficher.length>0) {
        id_departements_a_afficher.forEach(dep_id => {

          tauxincid = document.getElementById("tauxincid_"+dep_id ).value * taux_correction;
          pers = document.getElementById('pers_'+dep_id).value

          mult *= (1 - tauxincid/100000)**pers;
        })
      }

      resultat = Math.round((1-mult) * 1000)/10

      if (resultat > 5){
        resultat = Math.round(resultat);

      }

      document.getElementById("nb_pers_result").innerHTML = nb_pers_tot;
      document.getElementById("nb_pers_result_buttons").innerHTML = nb_pers_tot;

      document.getElementById("resultat").style.color = "black";
      document.getElementById("div_calculateur").style.boxShadow = "7px 4px 15px #d6d6d6"
      color="black";

      if(resultat>5){
        color="orange";
        document.getElementById("resultat").style.color = "orange";
        document.getElementById("div_calculateur").style.boxShadow = "7px 4px 15px #e6d5a5";}

      if(resultat>30){
        color="red";
        document.getElementById("resultat").style.color = "red";
        document.getElementById("div_calculateur").style.boxShadow = "7px 4px 15px #e6aca5";
      }

      if(resultat<1){
        color="green";
        document.getElementById("resultat").style.color = "green";
        document.getElementById("div_calculateur").style.boxShadow = "7px 4px 15px #afe6a5"
      }

      document.getElementById("progress_bar").innerHTML = "<progress style='' id='pg' type={{color}} value={{val}} max='100'></progress>"
      .replace("{{val}}", resultat.toString()).replace("{{color}}", color);

      document.getElementById("risque_autrement").innerHTML = resultat.toString().replace(".", ",");

      document.getElementById("taux_incid_corrigé_0").innerHTML = "(taux corrigé x" + taux_correction + " : " + document.getElementById("tauxincid_0").value*taux_correction   + ")" ;
      id_departements_a_afficher.forEach(id_dep => {
        document.getElementById("taux_incid_corrigé_"+id_dep).innerHTML = "(taux corrigé x" + taux_correction + ": " + incidence_a_afficher[id_dep]*taux_correction + ")";
      })
      calculerNbCasContacts();
      create_buttons();

    }

    function numberWithCommas(x) {
    return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, " ");
  }

    function calculerNbCasContacts(){
      pers = calculerNbPersTot();
      nb_contacts_risque_total = 0;

      

      document.getElementById("nb_pers_result_cas_contacts").innerHTML = pers;

      departements.forEach(dep => {
        tauxincid = incidence_departements[dep]["incidence_cas"]
        population_dep = incidence_departements[dep]["population"]

        risque = (1-(1-tauxincid*taux_correction/100000)**pers);

        nb_evenements_dans_dep = population_dep / pers
        nb_contacts_risque_total += risque * nb_evenements_dans_dep * (pers-1);

      })

      if (nb_contacts_risque_total > 1000000){
        nb_contacts_risque_total_string = nb_contacts_risque_total/1000000 + " millions"
      } else {
        nb_contacts_risque_total_string = pers
      }

      document.getElementById("cas_contacts").innerHTML = numberWithCommas(parseInt(nb_contacts_risque_total));

    } 

    function updateButtonColor(dep){
      try{
      document.getElementById(dep).classList.add("buttonSelected");
      if(selectedDep.length > 0){
        document.getElementById(selectedDep.replace("'", "\'")).classList.remove("buttonSelected");
      }
      selectedDep = dep;

    } catch (erreur) {
      console.log(erreur)
    }
  }


   function create_buttons(readmore=true){
        html_deps = "";
        nb_pers_tot = calculerNbPersTot();

        departements.map((dep, idx) => {
          taux_incid = incidence_departements[dep]["incidence_cas"]
          risque = Math.round((1-(1-taux_incid*parseInt(taux_correction)/100000)**nb_pers_tot) *100)
          
          color = "black";

          if(risque>10){
            color="orange";
          }

          if(risque>50){
            color="red";
          }

          if(risque<1){
            color="green";
          }

          if(readmore){
              if(idx<20){
           html_deps += "<button type='button_dep' style='padding: 10px; margin:5px;' id=\"" + replaceBadCharacters(dep) + "\" onclick=\"buttonHasChanged('" + replaceBadCharacters(dep) + "', 'true')\"><b>" + dep + "</b><br><span style='color:" + color + "'>" + risque + " %</span></button>";
          }
        }
        if(readmore==false){
          html_deps += "<button type='button_dep' style='padding: 10px; margin:5px;' id=\"" + replaceBadCharacters(dep) + "\" onclick=\"buttonHasChanged('" + replaceBadCharacters(dep) + "', 'true')\"><b>" + dep + "</b><br><span style='color:" + color + "'>" + risque + " %</span></button>";

        }
        })
        if(readmore){
          html_deps += "<br><button style='margin-top:20px;' type='form-btn' onclick='create_buttons(false)'>Afficher tous les départements...</button>"
        } else {
          html_deps += "<br><button style='margin-top:20px;' type='form-btn' onclick='create_buttons(true)'>Afficher moins...</button>"
        }
        document.getElementById("buttons-deps").innerHTML = html_deps
   }

   function buttonHasChanged(dep){
    scrollToTop();
    document.getElementById("deps_list_choice_0").value = dep;

    listHasChanged();
   }

    </script>
    <!-- /wp:html -->